program brenky;

{ 01.06.95 - 16.07.95:  Entwurf Images                                      }
{ 17.07.95 : Konvertierung der Images, Brenkys Bewegungen                   }
{ 18.07.95 : Spielfeld, Anzeigen: Level Levelname Zeit Punkte Brenkys Turns }
{            Auswertung: Transporter Loecher Turns Goodies Fledermaeuse     }
{ 22.07.95 : Zeitschleife/Optimierung, Check auf Brenky weg, Level fertig   }
{            ein paar Testrunden auf 486 DX 66/2 + Novell                   }
{ 31.08.95 : erste durchspielbare Version mit beweglichen Goodies           }
{ 09.09.95 : Erweiterung auf 4 Farben, unter konstanter Abwehr von Dieter   }
{ 10.09.95 : Version 1.000: Level 1 - 6, HighScore                          }

{ 17.09.95 : Tic-Warnung bei den letzten 30 s, Goodies haeufiger            }
{ 23.09.95 : Images: Bart und Brille fuer Brenky                            }

uses printer,crt,dos,graph,intuit,hiscore;

const header =' o      Brenky from Rear World      o      V.1.001 09/95    o     TP6     o';
      imafile='brenky.ima';
      hscfile='brenky.hsc';
      levfile='brenky.l';
      dx=48;   dy=40;   ox=-40;   oy=36;   xmax=13; ymax=9;
      liste  : array[0..79] of integer
             = (30,31,32,33,34,35,36,37,38,39,40,41,28,28,28,28,
                42,43,44,45,46,47,48,49,50,51,52,53,28,28,28,28,
                54,55,56,57,58,59,60,61,62,63,64,65,28,28,28,28,
                66,67,68,69,70,71,72,73,74,75,76,77,28,28,27,28,
                29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29);



type feld  =array[0..(xmax+2),0..(ymax+2)] of integer;
     tliste=array[0..15,0..3] of integer;
     { wegen goodie: 0:x, 1:y, 2:ri, 3:typ }

var  ima                                           :array[0..79] of image;
     backima                                       :image;
     i,j,k,level,bx,by,bz,bc,ntrans,nc,ng,zeit,brenkys,ax,ay,timing:integer;
     levelname                                     :string;
     cc,c1,c2                                      :char;
     punkte,ti1,ti2                                :longint;
     ho,mi,se,tic,ho1,mi1,se1,tic1                 :word;
     f,f0                                          :feld;
     t,g                                           :tliste;
     hsc                                           :highscore;
     ok,ende,aus,fertig,brenkyweg                  :boolean;
{ -------------------------------------------------------------------------- }

procedure delay1(ms:word);
assembler;
asm
   mov ax,1000;
   mul ms;
   mov cx,dx;
   mov dx,ax;
   mov ah,$86
   int $15;
end;




{$i initbren.inc }

procedure initlevel(var level,nc,ntrans,ax,ay:integer;
                    var levelname:string; var f:feld; var t:tliste);
var i,j:integer;
begin
   for i:=2 to xmax-1 do for j:=1 to ymax-1 do f[i,j]:=0;
   f[1,1]:=64; f[xmax,ymax-1]:=65;
   for i:=3 to 4 do for j:=5 to 7 do begin
      f[i,j]:=63;
      f[xmax-i+1,j]:=63;
   end;
   for i:=6 to 8 do for j:=6 to 7 do f[i,j]:=63;
   level:=0;
   levelname:='Just for a test!';
   ax:=1;
   ay:=2;
   ntrans:=2;
   t[0,0]:=1;    t[0,1]:=1;
   t[1,0]:=xmax; t[1,1]:=pred(ymax);
   nc:=4; zeit:=500;
end;

procedure ladelevel(var level,nc,ntrans,ax,ay:integer;
                    var levelname:string; var f:feld; var t:tliste);
var temp:string; i,j,k:integer; disk:text;
begin
   str(level:2,temp);
   for i:=1 to 2 do if temp[i]=' ' then temp[i]:='0';
   temp:=levfile+temp;
   for i:=0 to xmax+2 do for j:=0 to ymax+2 do f[i,j]:=63;

{$i-}
   assign(disk,temp);
   reset(disk);
   if ioresult=0 then begin
      readln(disk,levelname);
      readln(disk,zeit);
      readln(disk,nc);
      readln(disk,ng);
      k:=0;
      for i:=1 to ymax do begin
         readln(disk,temp);
         for j:=1 to length(temp) do begin
            case temp[j] of
            ' ': f[j,i]:=63;
            '#': f[j,i]:=0;
            '1': f[j,i]:=16;
            '2': f[j,i]:=32;
            'B': begin ax:=j; ay:=i; end;
            'T': begin f[j,i]:=k+64; t[k,0]:=j; t[k,1]:=i; inc(k); end;
            else f[j,i]:=62;
            end;
         end;
      end;
      close(disk);
      ntrans:=k;
   end else initlevel(level,nc,ntrans,ax,ay,levelname,f,t);
{$i+}
end;




procedure zeichnefeld(n,bx,by:integer; titel:string; f:feld);
var temp,t2:string;
begin
   for i:=1 to xmax do for j:=0 to ymax do
   putimage(i*dx+ox,j*dy+oy,ima[liste[f[i,j]]].p_data^,normalput);
   rectfill(16,456,631,471,0);
   rectfill(8,448,623,463,13);

   str(n:2,temp);
   str(nc:1,t2);
   titel:=copy(titel+'                    ',1,16);
   temp:='Lev.'+temp+' - '+titel+' - Turns '+t2+' - Punkte xxxxxx - Zeit xxx';
   temp:=temp+' - Brenkys x';
   setcolor(15); line(8,448,8,463); line(8,448,623,448);
   outtextxy(17,452,temp);
   setcolor(0);  outtextxy(16,452,temp);
end;

procedure showtime(n:integer);
var temp:string;
begin
   str(n:4,temp);
   rectfill(484,452,519,463,13);
   if n<100 then setcolor(7) else setcolor(15);
   outtextxy(485,452,temp);
   if n<100 then setcolor(8) else setcolor(0);
   outtextxy(484,452,temp);
end;

procedure showpunkte(n:longint);
var temp:string;
begin
   str(n:6,temp);
   rectfill(376,452,423,463,13);
   setcolor(15);
   outtextxy(377,452,temp);
   setcolor(0);
   outtextxy(376,452,temp);
end;

procedure showbrenkys(n:integer);
var temp:string;
begin
   str(n:1,temp);
   rectfill(596,452,607,463,13);
   if n<2 then setcolor(7) else setcolor(15);
   outtextxy(597,452,temp);
   if n<2 then setcolor(8) else setcolor(0);
   outtextxy(596,452,temp);
end;


procedure zeichnebrenky(bx,by,bz:integer);
var k:integer;
begin
   putimage(ox+bx*dx,oy+pred(by)*dy,ima[liste[f[bx,pred(by)]]].p_data^,normalput);
   putimage(ox+bx*dx,oy+dy*by,ima[liste[f[bx,by]]].p_data^,normalput);
   if not brenkyweg then begin
      case bz of
      0: k:=2;
      1: k:=8;
      2: k:=5;
      3: k:=11;
     10..20: k:=1;
      else k:=2;
     end;
     putimage(ox+bx*dx,oy+dy*pred(by),ima[k].p_data^,andput);
     putimage(ox+bx*dx,oy+dy*pred(by),ima[k+13].p_data^,orput);
   end;
end;

{ ------------------------------------------------------------- }

procedure initgoodie(l:integer; var g:tliste; var f:feld);
var i,j,k,element:integer;
begin
   if g[0,0]<4 then if l>0 then begin
      i:=succ(random(1000) mod xmax);
      case l of
      1: element:=2;
      2: element:=succ(random(100) mod 4);
      3: element:=succ(random(100) mod 7);
      4: element:=succ(random(100) mod 10);
      else element:=succ(random(100) mod 11);
      end;
      if (element>8) and (element<11) then element:=8; { Hund2 nach vorn }
      if (element>5) and (element<8) then element:=5;  { Hund1 nach vorn }
      j:=1;
      while (f[i,j]>60) and (j<ymax) do inc(j);
      if j<ymax then begin { Goodie setzen: }
         if (element=5) or (element=8) then k:=0 else k:=f[i,j] shr 4;
         f[i,j]:=(k shl 4);
         putimage(i*dx+ox,j*dy+oy,ima[liste[f[i,j]]+element].p_data^,normalput);
         inc(g[0,0]);
         g[g[0,0],0]:=i;
         g[g[0,0],1]:=j;
         g[g[0,0],2]:=0; { Richtung: nach vorne }
         g[g[0,0],3]:=element;
      end;
   end;
end;

{ --- }

procedure goodieweg(i:integer; var g:tliste; var f:feld);
var k:integer;
begin
   putimage(g[i,0]*dx+ox,g[i,1]*dy+oy,ima[liste[f[g[i,0],g[i,1]]]].p_data^,normalput);
   for k:=0 to 3 do g[i,k]:=g[g[0,0],k];
   dec(g[0,0]);
end;

{ --- }

procedure zusammenstoss(var bx,by,bz:integer; var g:tliste; var f:feld);
var i,j,k,b1,b2:integer;
begin
   { Goodie suchen in Liste: }
   if g[0,0]>0 then for i:=1 to g[0,0] do
   if (g[i,0]=bx) and (g[i,1]=by) then begin
      sound(150);
      delay1(100);
      nosound;
      case g[i,3] of
      1: if brenkys<5 then begin
            inc(brenkys);
            showbrenkys(brenkys);
         end;
      2: begin
            punkte:=punkte+succ(level)*50;
            showpunkte(punkte);
         end;
      3: begin
            punkte:=punkte+20*succ(level);
            showpunkte(punkte);
         end;
      4: begin
            punkte:=punkte+10*succ(level);
            showpunkte(punkte);
         end;
     11: begin
            brenkyweg:=true;
            for j:=500 downto 50 do begin
              sound(j);
              delay1(2);
            end;
            nosound;
            zeichnebrenky(bx,by,bz);
            bx:=ax; by:=ay;
            zeichnebrenky(bx,by,bz);
         end;
  8..10: bz:=20;
      end;
      goodieweg(i,g,f);
   end;
end;
{ --------------------------------------------------------------------- }

procedure movegoodies;
var i,x,y,typ,temp:integer;
    ok            :boolean;
begin
   temp:=g[0,0];
   if temp>0 then for i:=1 to temp do begin
      { freies Feld suchen }
      x:=g[i,0];
      y:=g[i,1];
      typ:=g[i,3];
      putimage(x*dx+ox,y*dy+oy,ima[liste[f[x,y]]].p_data^,normalput);

      { nach unten }
      ok:=y<ymax;
      if ok then ok:=(f[x,succ(y)]<60);
      if ok then begin
         inc(y);
         g[i,1]:=y;
         g[i,2]:=0;
         if (typ>4) and (typ<8) then typ:=5;
         if (typ>7) and (typ<10) then typ:=8;
      end;

      if not ok then if x<xmax then begin
         ok:=(f[succ(x),y]<60);
         if ok then begin
            inc(x);
            g[i,0]:=x;
            g[i,2]:=2;
            if (typ>4) and (typ<8) then typ:=6;
            if (typ>7) and (typ<10) then typ:=9;
         end;
      end;

      if not ok then if g[i,2]=0 then if x>1 then begin
         ok:=(f[pred(x),y]<60);
         if ok then begin
            dec(x);
            g[i,0]:=x;
            g[i,2]:=2;
            if (typ>4) and (typ<8) then typ:=7;
            if (typ>7) and (typ<10) then typ:=10;
         end;
      end;

      if ok then begin
         if (typ>4) and (typ<11) then f[x,y]:=0;
         putimage(x*dx+ox,y*dy+oy,ima[liste[f[x,y]+typ]].p_data^,normalput);
      end else g[i,2]:=-1; { markieren zum Loeschen }
   end;
   if temp>0 then for i:=1 to temp do
   if g[i,2]<0 then goodieweg(i,g,f);
   zeichnebrenky(bx,by,bz);
end;

{ -------------------------------------------------------------------- }

{$i movebren.inc }
{$i auswbren.inc }

procedure initbrenky;
begin
   bx:=ax;
   by:=ay;
   bz:=4;
   putimage(bx*dx+ox,by*dy+oy,ima[liste[f[bx,by]]].p_data^,normalput);
   brenkyweg:=false;
   putimage(bx*dx+ox,pred(by)*dy+oy,ima[2].p_data^,andput);
   putimage(bx*dx+ox,pred(by)*dy+oy,ima[15].p_data^,orput);
end;

procedure neuesspiel;
begin
   punkte:=0;
   zeit:=300;  { kann auf 150 reduziert werden }
   brenkys:=5;
   level:=1;
   nc:=3;
   aus:=false;
end;

procedure neueslevel;
begin
   { neues Level: }
   ladelevel(level,nc,ntrans,ax,ay,levelname,f,t);
   zeichnefeld(level,ax,ay,levelname,f);
   showtime(zeit);
   showpunkte(punkte);
   showbrenkys(brenkys);
   gettime(ho,mi,se,tic);
   initbrenky;
   cc:='.';
   fertig:=false;
   g[0,0]:=0;
end;


{ ------------------------------------------------------------- }

procedure hiscorescreen;
var i,j:integer; temp:string;
begin
   for i:=1 to xmax do for j:=0 to ymax+1 do
   putimage(i*dx+ox,j*dy+oy,ima[28].p_data^,normalput);

   rectfill(16,456,631,471,0);
   rectfill(8,448,623,463,13);
   temp:=' o                    T o p   T e n   B r e n k i e s                    o ';
   setcolor(15); line(8,448,8,463); line(8,448,623,448);
   outtextxy(17,452,temp);
   setcolor(0);  outtextxy(16,452,temp);

   for i:=3 to xmax-2 do begin
   if odd(i) then putimage(i*dx+ox,pred(ymax)*dy+oy,ima[44].p_data^,normalput)
             else putimage(i*dx+ox,pred(ymax)*dy+oy,ima[33].p_data^,normalput);
   if odd(i) then putimage(i*dx+ox,2*dy+oy,ima[31].p_data^,normalput)
             else putimage(i*dx+ox,2*dy+oy,ima[77].p_data^,normalput);
   end;
   for j:=3 to ymax-2 do
      if odd(j) then putimage(3*dx+ox,j*dy+oy,ima[63].p_data^,normalput)
                else putimage(3*dx+ox,j*dy+oy,ima[35].p_data^,normalput);

   putimage((xmax-2)*dx+ox,(ymax-3)*dy+oy,ima[11].p_data^,andput);
   putimage((xmax-2)*dx+ox,(ymax-3)*dy+oy,ima[24].p_data^,orput);

end;




{ ------------------------------------------------------------- }
procedure zeitschleife;
begin
   gettime(ho1,mi1,se1,tic1);
   if se1<se then tic:=60+se1-se else tic:=se1-se;
   se:=se1;
   if tic>0 then begin
      zeit:=zeit-tic;
      showtime(zeit);
      se:=se1;
      if bz>9 then begin
         dec(bz);
         sound(bz*6);
         delay1(90);
         nosound;
         delay1(10);
      end;

      movegoodies;
      zusammenstoss(bx,by,bz,g,f);
      zeichnebrenky(bx,by,bz);

      if zeit<30 then begin
         sound(5000);
         delay(5);
         nosound;
      end;
      if random(100)<10 then initgoodie(ng,g,f);
      if bz=9 then begin
         putimage(bx*dx+ox,pred(by)*dy+oy,ima[2].p_data^,andput);
         putimage(bx*dx+ox,pred(by)*dy+oy,ima[15].p_data^,orput);
         bz:=0;
      end;
      if zeit<=0 then aus:=true; { finito }
   end; { Zeitschleife }
end;

procedure tastaturauswertung;
begin

{ Tastatursteuerung, letzten Tastendruck holen: }
   c1:='.';
   c2:='.';
   if keypressed then repeat
      c1:=c2;
      c2:=readkey;
   until not keypressed;

{ Tastaturauswertung: }
   if c1=#0 then begin   { Cursor }
      if bz<10 then begin   { beweglicher Brenky }
         bz:=4;
         case c2 of
         #72: if by>1 then bz:=2; { Cursor up }
         #75: if bx>1 then bz:=3;
         #77: if bx<xmax then bz:=1;
         #80: if by<ymax then bz:=0;                   { down }
         end; { case }
         if bz<4 then begin
            movebrenky(bx,by,bz,timing);
            zusammenstoss(bx,by,bz,g,f);
            auswertung(nc,ntrans,bx,by,bz,f,punkte,brenkyweg);
         end;
      end;
   end else case c2 of  { normale Keys: }
   #27:     ende:=true;
   'P','p': begin
               while keypressed do cc:=readkey;  { Keyb. abrumen }
               cc:=readkey;                      { ... und weiter }
            end;
   '+'    : begin
               inc(level);
               neueslevel;
               initbrenky;
            end;
   '-'    : begin
               dec(level);
               neueslevel;
               initbrenky;
            end;
   end; { case }
   fertig:=true;
   for i:=1 to xmax do for j:=1 to ymax do
   if f[i,j]<60 then if (f[i,j] shr 4)<>pred(nc) then fertig:=false;
end;

{ --------------------------------------------------------------------- }
procedure fanfare1;
const ti=25;
begin
sound(165); delay(15*ti); nosound; delay(5*ti);
sound(220); delay(55*ti); nosound; delay(5*ti);
sound(248); delay( 5*ti); nosound; delay(5*ti);
sound(165); delay( 5*ti); nosound; delay(5*ti);
sound(248); delay(10*ti); nosound; delay(10*ti);
sound(278); delay(55*ti); nosound; delay(5*ti);
sound(278); delay( 5*ti); nosound; delay(5*ti);
sound(292); delay( 5*ti); nosound; delay(5*ti);
sound(220); delay(10*ti); nosound; delay(10*ti);
sound(278); delay(35*ti); nosound; delay(5*ti);
sound(248); delay( 5*ti); nosound; delay(5*ti);
sound(220); delay(15*ti); nosound; delay(5*ti);
ende:=readkey=#27;
end;

procedure fanfare2;
const ti=30;
begin
sound(220); delay(20*ti); nosound; delay(5*ti);
sound(220); delay(10*ti); nosound; delay(5*ti);
sound(220); delay(5 *ti); nosound; delay(5*ti);
sound(220); delay(20*ti); nosound; delay(5*ti);
sound(260); delay(15*ti); nosound; delay(5*ti);
sound(248); delay( 5*ti); nosound; delay(5*ti);
sound(248); delay(20*ti); nosound; delay(5*ti);
sound(220); delay(15*ti); nosound; delay(5*ti);
sound(210); delay( 5*ti); nosound; delay(5*ti);
sound(220); delay(25*ti); nosound; delay(5*ti);
ende:=readkey=#27;
end;




begin

initscreen(ok);
timing:=50;
if paramcount>0 then begin
   val(paramstr(1),k,i);
   if (k>1) and (k<50) then timing:=k*15;
end;

if ok then begin
   { allgemeiner Teil: }
   farbensetzen;
   initimas;
   loadhighscore(hscfile,hsc);
   zeichnebackgr;
   hiscorescreen;
   showhighscore(hsc,ox+5*dx,oy+4*dy,12,13,15,0,10);
   ende:=readkey=#27;

   if not ende then repeat
      neuesspiel;
      neueslevel;
    { Game Loop: }
      repeat
         if brenkyweg then begin
            while keypressed do cc:=readkey;
            dec(brenkys);
            showbrenkys(brenkys);
            aus:=brenkys<1;
            if aus then
            putimage(bx*dx+ox,pred(by)*dy+oy,ima[1].p_data^,andput)
            else initbrenky;
         end;

         if not aus or fertig then begin
            zeitschleife;
            tastaturauswertung;

            if fertig then begin
               punkte:=punkte+zeit+100*level;
               showpunkte(punkte);
               fanfare1;
               inc(level);
               neueslevel;
               initbrenky;
            end;
         end;
      until aus or ende;
      if aus then fanfare2;
      hiscorescreen;
      updathighscore(punkte,hscfile,hsc,ox+5*dx,oy+4*dy,12,13,15,0,2);
      ende:=readkey=#27;
   until ende;
   textmode(3);
end;
end.


